"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _router = require("next/router");

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const withRouterRef = WrappedComponent => {
  const WithRouterRef = (0, _react.forwardRef)((props, ref) => {
    const router = (0, _router.useRouter)();
    return _react.default.createElement(WrappedComponent, Object.assign({
      ref: ref,
      router: router
    }, props));
  });
  WithRouterRef.displayName = `withRouterRef(${WrappedComponent.displayName || WrappedComponent.name ||
  /* istanbul ignore next */
  'Component'})`;
  (0, _hoistNonReactStatics.default)(WithRouterRef, WrappedComponent);
  return WithRouterRef;
};

var _default = withRouterRef;
exports.default = _default;
module.exports = exports.default;